@echo off

if "%1"=="" (
	echo You must specify the robot's IP address as the command line argument
	exit /B
)

set /a retries=0
:start

echo Disconnecting any existing adb connections...
adb disconnect > NUL
timeout /t 3 /nobreak > NUL

echo Connecting to %1...
for /f %%i in ('adb connect %1:5555') do set response=%%i
if not x%response:cannot=%==x%response% (
	echo Unable to establish an adb connection at this address
	exit /B
)
timeout /t 3 /nobreak > NUL
echo Connected

echo Setting adb root...
adb root
timeout /t 5 /nobreak > NUL

rem Confirming connection
for /f %%i in ('adb devices') do set response=%%i
if x%response:5555=%==x%response% (
	set /a retries+=1
	if %retries% gtr 1 (
		echo Patch failed. Please screen capture the terminal and contact Misty Robotics for support.
		exit /B
	)
	echo Lost connection. Retrying.
	goto start
)

echo Applying patch...
adb -s %1:5555 remount /vendor/bin > NUL
adb -s %1:5555 push init.misty.sh /vendor/bin > NUL
adb -s %1:5555 shell "chmod 755 /vendor/bin/init.misty.sh"
adb -s %1:5555 shell "chown root:shell /vendor/bin/init.misty.sh"
adb -s %1:5555 shell "mkdir -p /data/misty/scripts"
adb -s %1:5555 push scripts.tar /sdcard/ > NUL
adb -s %1:5555 shell "mkdir -p /data/misty/patches"
adb -s %1:5555 shell "touch /data/misty/patches/patch1.0.5"

echo Patch complete
echo Rebooting 820 processor
adb -s %1:5555 reboot
adb -s %1:5555 disconnect > NUL
